#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/resource.h>

#define _ntl_ulong unsigned long

#include "mul1.c"
#include "Mul1.c"
#include "AddMul1.c"
#include "mul.c"

/* #define N n */
#define N 200000

int
cputime ()
{
  struct rusage rus;

  getrusage (0, &rus);
  return rus.ru_utime.tv_sec * 1000 + rus.ru_utime.tv_usec / 1000;
}

unsigned long KarMulMem (unsigned long n)
{
  unsigned long hn, sp;

  sp = 0;
  while (n > 1)
    {
      hn = (n + 1) >> 1;
      sp += (hn << 2) + 3;
      n = hn;
    }
  return sp;
}

unsigned long ToomMulMem (unsigned long n)
{
  unsigned long hn, sp;

  sp = 0;
  while (n > 1)
    {
      hn = (n + 1) >> 1;
      sp += (hn << 3) + 3;
      n = hn;
    }
  return sp;
}

int
main (int argc, char *argv[])
{
  unsigned long n;
  unsigned long i, *c, *a, *b, *stk, *c0, *d;
  int st;
  int nokara = 0;
  _ntl_ulong cy = 0UL;

  if (strcmp (argv[1], "-nokara") == 0)
    {
      nokara = 1;
      argc --;
      argv ++;
    }

  n = atoi (argv[1]);

  a = (unsigned long*) malloc (n * sizeof(unsigned long));
  b = (unsigned long*) malloc (n * sizeof(unsigned long));
  c = (unsigned long*) malloc (2 * n * sizeof(unsigned long));
  c0 = (unsigned long*) malloc (2 * n * sizeof(unsigned long));
  stk = (unsigned long*) malloc (ToomMulMem (n) * sizeof(unsigned long));

  for (i = 0; i < n; i++)
    {
      a[i] = (unsigned long) lrand48 ();
      b[i] = (unsigned long) lrand48 ();
    }

  a[n-1] &= 0xf;

  if (1) /* check exact divisions */
    {
      b[n-1] &= 0xfffffff;
      d = (unsigned long*) malloc (n * sizeof(unsigned long));
      AddLsh1(d,b,b,n);
      DivOnePlusX(d,n);
      for ( i = 0; i<n; i++)
	if ( d[i] != b[i] ) {
	  printf ("Div(x+1)!%d",i); break;
	}
      AddLsh2(d,b,b,n);
      DivOnePlusX2(d,n);
      for ( i = 0; i<n; i++)
	if ( d[i] != b[i] ) {
	  printf ("Div(x^2+1)!%d",i); break;
	}
      AddLsh3(d,b,b,n);
      Lsh1(d,n,cy);
      DivExactD1(d,n);
      for ( i = 0; i<n; i++)
	if ( d[i] != b[i] ) {
	  printf ("Div(x^4+x)!%d",i); break;
	}
      AddLsh2(d,b,b,n);
      Lsh1(d,n,cy);Lsh1(d,n,cy);
      DivExactD2(d,n);
      for ( i = 0; i<n; i++)
	if ( d[i] != b[i] ) {
	  printf ("Div(x^4+x^2)!%d",i); break;
	}

    }

  if (!nokara)
    printf ("n=%u: ", n);

  st = cputime ();
  for (i = 0; i < N/n; i++)
      mul_basecase_n (c0, a, b, n);
  printf ("mul took %dms", (cputime () - st));
  
  if (nokara == 0)
    {
      st = cputime ();
      for (i = 0; i < N/n; i++)
        KarMul (c, a, b, n, stk);
      printf (", KM took %dms", cputime () - st);

      for ( i = 0; i<2*n; i++)
	if ( c[i] != c0[i] ) {
	  printf ("!");
	  break;
	}

      st = cputime ();
      for (i = 0; i < N/n; i++)
        ToomMul (c, a, b, n, stk);
      printf (", TM took %dms", cputime () - st);

      for ( i = 0; i<2*n; i++)
	if ( c[i] != c0[i] ) {
	  printf ("!");
	  break;
	}

      st = cputime ();
      for (i = 0; i < N/n; i++)
        Toom3Mul (c, a, b, n, stk);
      printf (", T3 took %dms", cputime () - st);

      for ( i = 0; i<2*n; i++)
	if ( c[i] != c0[i] ) {
	  printf ("!%d",i); break;
	}
/*       printf ("*%d",i); */

      st = cputime ();
      for (i = 0; i < N/n; i++)
        Toom4Mul (c, a, b, n, stk);
      printf (", T4 took %dms", cputime () - st);

      for ( i = 0; i<2*n; i++)
/* 	printf(( c[i] != c0[i] )?"+":"-"); */
	if ( c[i] != c0[i] ) {
	  printf ("!%d",i); break;
	}

    }

  printf ("\n");
}
